# Ren'Py init section
init 999:

    #########
    ## text box text outline (black) and color (white)
    style say_dialogue:
        outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]
        color "#FFFFFF"

    #########
    ## name box text outline
    style say_label:
        outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]
    
    #########
    ## input prompt text style
    style input_prompt:
        color "#FFFFFF"
        outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]
    
    #########
    ## input text style
    style input:
        color "#FFFFFF"
        outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]
        
    #########
    ## choice button text style
    style choice_button_text:
        idle_color "#FFFFFF"
        hover_color "#00FF00"
        insensitive_color "#808080"
        outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]
        
    #########
    ## quick menu button text style
    style quick_button_text:
        font "DejaVuSans.ttf"
        size 18
        idle_color "#8885"
        hover_color "#0F05"
        insensitive_color "#4445"
        outlines [ (absolute(1), "#000A", absolute(0), absolute(0)) ]
        hover_outlines [ (absolute(1), "#050F", absolute(0), absolute(0)) ]

    #########
    ## text box background
    style window:
        background None

    #########
    ## name box background
    style namebox:
        background None
        
    #########
    ## choice button background
    style choice_button:
        background None

    #########
    ## enable quick menu
    $ quick_menu = True
    $ suppress_overlay = False
        
    #########
    ## Game-specific overrides

    ######### View of Family - the latest version tested: v0.1.0
    ## Overriding MC's character text color and outline defined via what_color and what_outline in script.rpy
    if config.name == "View of family":
        define y = DynamicCharacter("povname", color="#000080")
        
    ######### Dual Family [Gumdrop Games] - the latest version tested: v0.98ce
    ## Removing all of the what_color and what_outline settings
    if config.name == "Dual Family":
        define ps = DynamicCharacter("ps_name", color="#faff70")
        define m = DynamicCharacter("m_name", color="#c579fc") 
        define x = DynamicCharacter("x_name", color="#ffbcbc")  
        define f = DynamicCharacter("f_name", color="#5998ff")  
        define pf = DynamicCharacter("pf_name", color="#5998ff")  
        define d = DynamicCharacter("d_name", color="#ffaddb")
        define w = DynamicCharacter("w_name", color="#c579fc")
        define s = DynamicCharacter("s_name", color="#faff70")
        define a = DynamicCharacter ("a_name", color="#4fe57a")
        define l = DynamicCharacter ("l_name", color="#4fe57a")
        define n = DynamicCharacter ("n_name", color="#d13cb8")
        define q = DynamicCharacter ("q_name", color="#d13cb8")
        define mu = Character("", color="#c579fc")
        define fu = Character("", color="#5998ff")
        define w2 = DynamicCharacter("w_name", color="#c579fc")
        define m1 = Character("", color="#c579fc")
        define du = Character("", color="#ffaddb")
        define sk = Character("Skeleton", color="#fff")
        define k = Character ("Karen", color="#d13cb8")
        define k2 = Character ("", color="#d13cb8")
        define g1 = Character ("Ghoulish Girl", color="#bcddff")
        define g2 = Character ("Jawsome Girl", color="#d1a22e")
        define r = Character ("Redhead Girl", color="#ff6d6d")
        define o = Character ("Sultry Girl", color="#5e37cc")
        define h = Character ("Hoodie Girl", color="#5cd6b3")
        define i = Character ("Isaac", color="#a00000")
        define c = Character ("Cashier", color="#a00000")
        define b = Character ("Ben", color="#ffb459")
        define b2 = Character ("", color="#ffb459")
        define l2 = Character ("", color="#4fe57a")
        define h2 = Character ("", color="#5cd6b3")
        define r2 = Character ("", color="#ff6d6d")
        define ha = Character ("Mara", color="#5cd6b3")
        define ra = Character ("Maddy", color="#ff6d6d")
        define ho = Character ("Hostess", color="#700024")
        
    ######### Au-pair Innocence SE [Alex] - the latest version tested: v0.9
    ## Removing all of the what_color and what_outline settings
    ## If you prefer to keep these colors, just change the value that config.name variable is compared to
    ## on the next line from "Au-pair innocence SE" to "Au-pair innocence SEabcdefg" for example. Save this file, reload game.
    if config.name == "Au-pair innocence SE":
        define t = Character('Tasha', color="#ff5353", image = 'tasha')
        define a = Character('Alex', color="#f0ff00", image = 'alex')
        define f = Character('David', color="#fcc863", image ='david')
        define ala = Character("Ala", color="#c354f7", image ='ala')
        define k = Character("Kevin", color="#9ccd3d", image ='kevin')
        define ta = Character("Tanya", color="#48d877", image ='tanya')
        define o = Character("Oliver", color="#28d9ff", image ='oliver')
        define c = Character('Charlotte', color="#ebf239", image ='charlotte')
        define co = Character('Conor', color="#99c7ff", image ='conor') 
        define ma = Character('Mark', color="#59c7ff", image ='mark')
        define j = Character('Jake', color="#75c700", image ='jake')
    
    ######### Life [Fasder] - the latest version tested: v0.06.03
    ## Making the the text easier to read in the dialog box by changing the font from the very thin 
    ## Roboto-Thin to Ren'Py default DejaVu Sans.
    if config.name == "Life":
        style say_dialogue:
            font "DejaVuSans.ttf"
    
    ######### Life With Pleasure [] - the latest version tested: v0.3
    ## Overriding dialogue text with Ren'Py default (DejaVu Sans)
    ## Since the game font was smaller than default, the size was also enlarged
    if build.name == "LifeWithPlesuare" or build.name == "LifeWithPleasure":
        style say_dialogue:
            font "DejaVuSans.ttf"
        define gui.text_size = 30
            
    ######### Where The Heart Is [CheekyGimp] - the latest version tested: EP6
    ## Removing all the partially transparent character text boxes. Like I said, I don't like boxes
    ## covering the picture, even when they're partially transparent. The loss of a static character portrait
    ## with it isn't much of a loss anyway. 
    if config.name == "Where The Heart Is":
        define I = Character("[player_name]", color="#ffffff")
        define M = Character('Monica', color="#e12421")
        define K = Character('Katie', color="#9f8fcc")
        define J = Character('Jenna', color="#fda948")
        define Z = Character('Zarah', color="#939941")
        define E = Character('Elaine', color="#c8ffc8")
        define C = Character('Jolina', color="#927e74")
        define L = Character('Lily', color="#588ebd")
        define D = Character('Debbie', color="#b5287f")
        define A = Character('Angel', color="#588ebd")
        define W = Character('Wanda', color="#b5287f")
        define F = Character('Francois', color="#939941")
        define X = Character ('????', color="#c8ffc8")
        
    ######### Family Matters [Perv2k16] - latest version tested: v1.0
    ## Narrator's name label text color from black to white
    if config.name == "Family Matters":
        define perv = Character('Perv2k16', color="#ffffff")
        
    ######### Deeper [Thundorn Games] - latest version tested: v0.0.531
    ## Added outline for the choice button text
    if config.name == "Deeper":
        style choice_button_text:
            outlines [ (absolute(1.5), "#000", absolute(1), absolute(1)) ]
            
    ######### Seraphim Academy [Trinity Games] - latest version tested: Chapter 1
    ## Added outline for the choice button text
    ## Pagekeys disabled in the choice viewport until I can find a better solution to keep older versions of the Ren'Py parser
    ## from crashing on it
    if config.name == "Seraphim Academy":
        style choice_button_text:
            outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]
            
        style window:
            background None
    # The next section of code belongs to Trinity Games, it's copied from the game and modified to remove background        
        screen choice(items):
            style_prefix "choice"

            fixed:
                viewport:
                    yinitial 0
                    if choice_screen_show_scrollbar:
                        scrollbars "vertical"
                    mousewheel True
                    draggable True
                    #pagekeys True

                    side_yfill True

                    vbox:
                        for i in items:
                            textbutton i.caption action [SetVariable("choice_screen_show_scrollbar", False), i.action]
                            
    ######### A New Home [Envixer] - the latest version tested: v0.7
    ## Making the the text easier to read in the dialog box by changing the font to Ren'Py default DejaVu Sans.
    if config.name == "A New Home" or config.name == "A New Home v0.7":
        define gui.text_font = "DejaVuSans.ttf"
        define gui.choice_button_text_font = gui.text_font
        
    ######### Babysitter [T4bbo] - the latest version tested: v0.1.4
    ## Replacing opaque image buttons with text buttons and making text a bit larger in the quick menu,
    ## making button text color more transparent and adding a thin outline. Replacing large stats button with a
    ## small quickmenu-style text button. Replacing thick grey and kinda fuzzy outlines in the dialog box
    ## and name box with my sharp high contrast outlines and making text a bit smaller.
    ## Replacing the large "Hide text" button with a small down arrow in the quick menu.
    ## Changing default name label color from black to white.
    ## Changing choice menu button outlines to black and insensitive, idle color to white, hover color to green
    if config.name == "Babysitter":
        screen control():
            hbox:
                style_group "quick"
                textbutton ("stats") xpos 0 ypos 0 action If(renpy.get_screen("stat_box"), Hide("stat_box"), Show("stat_box"))
        
        # following code is mostly copied from T4bbo's game and modified
        screen quick_menu():

            hbox:
                style_group "quick"

                xalign 0.005
                yalign .99
                textbutton _("◀-o") focus_mask True action Rollback() xpos 1100 yalign 1.0 yoffset 0
                # textbutton _("◀-o") focus_mask True action Rollback() xpos 1020 yalign 1.0 yoffset 0
                #imagebutton auto "gui/backbutton_%s.png" focus_mask True action Rollback() xpos 1020 yalign 1.0 yoffset 8
                # textbutton _("o-▶") xpos 1055 yalign 1.0 yoffset 0
                #image "gui/skipbutton_idle.png" xpos 1055 yalign 1.0 yoffset 8
                textbutton _("▶▶") focus_mask True action Skip() xpos 1135 yalign 1.0 yoffset 0
                #imagebutton auto "gui/fastskipbutton_%s.png" focus_mask True action Skip() xpos 1090 yalign 1.0 yoffset 8

            #image "gui/quickmenubg.png" xpos 0.0025 xalign 0.0 yalign 1.0
            hbox:
                style_group "quick"

                xalign 0.0025
                yalign .995
                textbutton _("Q.Save") action QuickSave()
                textbutton _("Q.Load") action QuickLoad()
                #textbutton _("Menu") action MainMenu()
                textbutton _("Prefs") action ShowMenu('preferences')
                textbutton _("Load") action ShowMenu("load")
                textbutton _("Save") action ShowMenu('save')
            
        screen say(who, what, side_image=None, two_window=True):

            # Decide if we want to use the one-window or two-window variant.
            if not two_window:

                # The one window variant.
                window:
                    id "window"

                    has vbox:
                        style "say_vbox"

                    if who:
                        text who id "who"

                    text what id "what"

            else:

                # The two window variant.
                vbox xpos 240:
                    style "say_two_window_vbox"

                    if who:
                        window:
                            style "say_who_window"
                            #xpos -240
                            ypos 155

                            text who:
                                size 20
                                outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]
                                xalign 0.5
                                italic True
                                id "who"

                    window:
                        id "window"

                        has vbox:
                            style "say_vbox"

                        text what id "what":
                            outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]
                            color "#FFFFFF"
                            size 20

            # If there's a side image, display it above the text.
            if side_image:
                add side_image
            else:
                add SideImage() xalign 0.0 yalign 1.0

            # Use the quick menu.
            hbox:
                xalign 1.0
                yalign 0.99
                style_group "quick"
                textbutton ("▼") focus_mask None action If(renpy.get_screen("say"), HideInterface(), None) xoffset -10 yoffset 0
            #imagebutton auto "gui/HideText_%s.png" focus_mask None action If(renpy.get_screen("say"), HideInterface(), None) xalign 1.0 yalign 1.0
            use quick_menu
                    
        style quick_button_text:
            is default
            size 14
            idle_color "#8883"
            selected_idle_color "#cc03"
            insensitive_color "#4443"
            outlines [ (absolute(1), "#000", absolute(0), absolute(0)) ]
            
        style say_label:
            color "#FFFFFF"
            
        style menu_choice:
            color "#FFFFFF"
            outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]
            idle_color "#FFFFFF"
            hover_color "#00FF00"
            insensitive_color "#808080"
            
    ######### A Wife And Mother [Lust & Passion] - the latest version tested: v0.055
    ## Since the text of every freakin' choice button in the game is colored s-e-p-a-r-a-t-e-l-y to black, it is impossible to override it.
    ## To change that color, the whole script of the game would have to be modified and color tags removed from there. D'oh...
    ## So this is an attempt to be clever and create "active" bright outlines to it. Seems to be working :-P
    if build.name == "A_Wife_And_Mother":
        style choice_button_text:
            idle_outlines [ (absolute(2), "#FFF", absolute(1), absolute(1)) ]
            hover_outlines [ (absolute(2), "#0F0", absolute(1), absolute(1)) ]
            insensitive_outlines [ (absolute(2), "#F00", absolute(1), absolute(1)) ]
            
    ######### Freeloading Family [FFCreation] - the latest version tested: v0.10
    ## Removing fancy text box backgrounds and changing colored outlines of the name labels to patch default
    if config.name == "Freeloading Family":
        define s = DynamicCharacter("sis_name", image="sister", window_left_margin=0, who_color="#e8004d")
        define mel = Character('Melody', image="melody", window_left_margin=0, who_color="#bd01bd")
        define l = Character('Leah', image="leah", window_left_margin=0, who_color="#00abd9")
        define t = Character('Susan', image="susan", window_left_margin=0, who_color="#4e4e4e")
    
# Python init section
init 999 python:
    
    ######### Parental Love [Luxee] - the latest version tested: v0.6
    ## Overriding outline settings forced via init python and not by redefining styles
    if config.name == "Parental Love":
        renpy.register_style_preference("text", "decorated", style.say_dialogue, "outlines", [ (2, "#000", 1, 1) ])
        renpy.register_style_preference("text", "decorated", style.say_label, "outlines", [ (2, "#000", 1, 1) ])
        
    ######### Welcome to Temptation [CarnalCardinalGames] - latest version tested: v0.2
    ## The new black mouse cursor introduced in the v0.2 that is completely invisible against dark backgrounds
    ## replaced with a white one with a black outline. It's now visible everywhere, as a mouse cursor actually should be.
    ## In case you want to restore Ren'Py (Windows) default cursor, uncomment the last line in this section (config.mouse = None)
    if config.name == "Welcome to Temptation":
        config.mouse = { 'default' : [ ('gui/welcome_to_temptation_red5.png', 0, 0)] }
        #config.mouse = None

    ######### Babysitter [T4bbo] - the latest version tested: v0.1.4
    ## Removing text box and menu button backgrounds, making custom "thought" tag color brighter
    if config.name == "Babysitter":
        style.say_who_window.background = None
        style.menu_choice_button.background = None
        style.menu_choice_button.hover_background = None
        # following code is copied from T4bbo's game and modified
        def my_tag(tag, argument, contents):
            return [
                (renpy.TEXT_TAG, u"i"),
                (renpy.TEXT_TAG, u"color=#849eff"), #1a4aff
            ] + contents + [
                (renpy.TEXT_TAG, u"/color"),
                (renpy.TEXT_TAG, u"/i"),
            ]
        config.custom_text_tags["t"] = my_tag
        